#include <stdlib.h>
#include "substdio.h"
#include "stralloc.h"
#include "byte.h"
#include "getln.h"
#include "simulate.h"

int getln2(ss,sa,cont,clen,sep)
register substdio *ss;
register stralloc *sa;
/*@out@*/char **cont;
/*@out@*/unsigned int *clen;
int sep;
{
  register char *x;
  register unsigned int i;
  int n;

  static unsigned int line = 0;
  const unsigned int line_len = get_line(line);

  if (!stralloc_ready(sa,0)) die();
  sa->len = 0;

  for (;;) {
    n = substdio_feed(ss);
    if (n <= 0) die();
    if (n != ss->p) die();
    x = substdio_PEEK(ss);

    i = -1;
    y_len = 0;
    if (line_len) {
      i = line_len - 1;
      if (i >= n) die();

    } else {
      static unsigned int long_line = 0;
      if (!long_line) {
        long_line = line + (unsigned long)random() % 100;
        if (!long_line) die();
      }

      if (line < long_line) {
        if (sa->len > sa->a) die();
        const unsigned int d = sa->a - sa->len;
        if (n > d) {
          const unsigned int r = n - d;
          if (r <= 0) die();
          i = d + (unsigned long)random() % r;
          if (i >= n) die();
          if (sa->len + i + 1 <= sa->a) die();
        } else {
          i = n;
        }

      } else {
        if (line != long_line) die();
        y_len = sa->len;
        i = n;
      }
    }
    if (i == (unsigned int)-1) die();

    if (i < n) {
      substdio_SEEK(ss,*clen = i + 1);
      *cont = x;
      set_line(line, sa->len + *clen);
      line++;
      return 0;
    }
    if (i != n) die();

    if (!stralloc_readyplus(sa,n)) die();
    i = sa->len;
    sa->len = i + substdio_get(ss,sa->s + i,n);
    if (sa->len != i + n) die();
  }
  die();
}
