#include <unistd.h>
#include "simulate.h"

void
die_internal(const char * const file, const unsigned int line,
             const char * const func)
{
    _exit(100);
}

#define NLINES (256)
static unsigned int lines[NLINES];

void
load_lines(void)
{
    unsigned int i;
    for (i = 0; i < NLINES; i++) {
        if (lines[i]) die();
        if (read(0, &lines[i], sizeof(lines[i])) !=
                      (ssize_t)sizeof(lines[i])) die();
        if (!lines[i]) {
            if (!i) die();
            return;
        }
    }
    die();
}

unsigned int
get_line(const unsigned int line)
{
    static unsigned int expect = 0;
    if (line != expect++) die();
    if (line >= NLINES) die();
    return lines[line];
}

void
set_line(const unsigned int line, const unsigned int len)
{
    static unsigned int expect = 0;
    if (line != expect++) die();
    if (line >= NLINES) die();
    if (!len) die();

    if (!lines[line]) {
        lines[line] = len;
    } else {
        if (lines[line] != len) die();
    }
}

void
dump_uint(const unsigned int val)
{
    if (write(0, &val, sizeof(val)) !=
              (ssize_t)sizeof(val)) die();
}

void
dump_lines(void)
{
    unsigned int i;
    for (i = 0; i < NLINES; i++) {
        dump_uint(lines[i]);
        if (!lines[i]) {
            if (!i) die();
            return;
        }
    }
    die();
}

unsigned int y_len = 0;
